//+------------------------------------------------------------------+
//|                                            TickScalper_v3.44.mq4 |
//|                             Copyright  2009-10, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009-10, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

//
//
//
//
//

#include <stdlib.mqh>

//
//
//
//
//

extern string     Expert_Name    = " TickScalper_v3.45 ";
extern bool       NoHedge        =  true;
extern bool       StrictNoHedge  =  true;
extern string     SymbolsPrefix  = "";
extern string     SymbolsSuffix  = "";
extern bool       UseAutoMagic   = true;
extern int        ManualMagic    = 12345678; 
extern int        Slippage       =     3;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =   0.1;    // Trade Volume 
extern int        MaxOrders      =     10;    // Max Number of Orders
extern double     TakeProfit     =     0;    // Take Profit Value in pips 
extern double     ProfitTarget   =     0;    // Profit Target acc to Profit Mode 
extern double     MinProfit      =     1;    // Min Profit in pips
extern double     ProfitMode     =     0;    // 0-Pips,1-Profit,2-Total Pips,3-Total Profit
extern double     StopLoss       =     100;    // Initial Stop Value in pips
extern int        TrailingMode   =     2;    // 0-off,1-standard,2-System by Up/Dn Bands  
extern double     TrailingStop   =     0;    // Trailing Stop Value in pips
extern double     StopDeviation  =     1;    // Deviation from Up/Dn Bands in %(TrailingMode=2)
extern double     BreakEven      =     0;    // Break-Even Value in pips
extern double     PipsLock       =     0;    // Lock in pips
extern int        ExitMode       =     10;   // Exit Mode
extern double     MaxSpread      =     0;    // Max Spread in pips  
extern int        ECN_Mode       =     1;    // 1-for ECN brokers  
extern int        ReverseLogic   =     0;
extern bool       DisplayComments=     true; // Comment Mode

extern string     Time_Inputs    = " Timing parameters ";
extern int        MainTimeFrame  =    -1;    // Time Frame in min(0-current, -1-each tick mode)
extern int        StartHour      =     6;    // Start Hour of Trade Session 
extern int        StartMinute    =     0;    // Start Minute of Trade Session 
extern int        EndHour        =    22;    // End Hour of Trade Session
extern int        EndMinute      =     0;    // End Hour of Trade Session
extern int        MonStartHour   =     8;    // Monday Start Hour of Trade Session 
extern int        MonStartMinute =     0;    // Monday Start Minute of Trade Session 
extern int        FriEndHour     =    18;    // Friday End Hour of Trade Session
extern int        FriEndMinute   =     0;    // Friday End Hour of Trade Session
extern int        TradeDay       =    -1;    // Trade Day of Week (ex.1-Monday,-1-all Days) 
extern int        NonTradeDay    =     0;    // Non Trade Day of Week
extern int        CloseTimeMode  =     0;    // CloseTime mode: 0-off,1-on
extern int        CloseHour      =    24;    // Trade Close Hour   
extern int        CloseMinute    =     0;    // Trade Close Minute   
extern int        FriCloseHour   =    20;    // Trade Close Hour in Friday   
extern int        FriCloseMinute =    55;    // Trade Close Minute in Friday 
extern double     ProcessTime    =     3;

extern string     TS_Inputs      = " TickSmoother parameters:";
extern int        TS_TimeFrame   =    -1;    // Time Frame in min(<0 - for ticks)
extern int        TS_Price       =     0;    // 0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted Close
extern int        TS_FastMA      =     9;    // Fast MA Length(Period)
extern int        TS_SlowMA      =    20;    // Slow MA Length(Period)
extern int        TS_ConfMA1     =    55;    // Confirm MA1 Length(Period)
extern int        TS_ConfMA2     =   120;    // Confirm MA2 Length(Period)
extern int        TS_MA_Mode     =     1;    // MA Mode: 0-SMA,1-EMA,2-Wilder(SMMA),3-LWMA 
extern int        TS_NumTicks    =     0;    // TimeFrame in ticks (=0 if NumSecs  > 0)
extern int        TS_NumSecs     =    10;    // TimeFrame in secs  (=0 if NumTicks > 0) 
extern int        TS_MaxBars     =   500;    // Max Number of ticks   
extern int        TS_Shift       =     1;    // Shift relative to the current bar
extern int        FastPeriod     =    12;
extern int        SlowPeriod     =    26;
extern int        SignalPeriod   =     9;
extern int        Method         =     8;    // Mode: 0-off,7-RSI,8-averages macd
extern int        TS_Mode        =     6;    // Mode: 0-off
extern int        macdtf         =     5;
extern string     MAforMacdTypes = "";
extern string     __0            = "SMA";
extern string     __1            = "EMA";
extern string     __2            = "Double smoothed EMA";
extern string     __3            = "Double EMA (DEMA)";
extern string     __4            = "Triple EMA (TEMA)";
extern string     __5            = "Leader EMA";
extern string     __6            = "Smoothed MA";
extern string     __7            = "Linear weighted MA";
extern string     __8            = "Parabolic weighted MA";
extern string     __9            = "Alexander MA";
extern string     __10           = "Volume weghted MA";
extern string     __11           = "Hull MA";
extern string     __12           = "Triangular MA";
extern string     __13           = "Sine weighted MA";
extern string     __14           = "Linear regression";
extern string     __15           = "IE/2";
extern string     __16           = "NonLag MA";
extern string     __17           = "Zero lag EMA";

extern string     MC_Inputs      = " MAs Confirmation parameters:";
extern int        MC_TimeFrame   =     15;   // Time Frame in min
extern int        MC_Price       =     0;    // 0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted Close
extern int        MC_FastMA      =     9;    // Fast MA Length(Period)
extern int        MC_SlowMA      =    20;    // Slow MA Length(Period)
extern int        MC_ConfMA1     =    55;    // Confirm MA1 Length(Period)
extern int        MC_ConfMA2     =   120;    // Confirm MA2 Length(Period)
extern int        MC_MA_Mode     =     1;    // MA Mode: 0-SMA,1-EMA,2-Wilder(SMMA),3-LWMA 
extern int        MC_Shift       =     0;    // Shift relative to the current bar
extern int        Price          =     8;
extern int        MC_Mode        =     3;   

extern string     MM_inputs                     = " MoneyManagement by L.Williams ";
extern int        MM                            =     1;    //  Switch
extern double     MaxRisk                       =  0.03;    // Risk Factor
extern double     MaxLoss                       =     0;    // Maximum Loss by 1 Lot
extern double     MGMode                        =     1;
extern double     MGRatio                       =     2;
extern double     MGStep                        =    15;
extern double     MGPips                        =    15;

extern bool       EquityTrailing                = True;  // To enable a equity trail,for now should only work if max orders is triggered,it will close all orders when equity show profit
extern double     PercentEquityTrailing         = 1;     // Percent of profit to start the closure off all the orders.

//
//
//
//
//

int      OrderBar = 0;
int      cross = 0;
int      BEbar;
int      NumOrders;
int      BEvent = 0, TriesNum = 5;
int      EquityStop;
int      MNEACode, MNSymbol, MNPeriod, a;
int      Magic;

double   tClose, slowMA, fastMA, tClose1, slowMA1, fastMA1, confMA1, confMA2;
double   mClose, mslowMA, mfastMA, mClose1, mslowMA1, mfastMA1, mconfMA1, mconfMA2;
double   lot_min;
double   lot_max;
double   lot_step;
double   contract; 
double   tick_val,spread;
double   minstop;
double   Lotsi;  
double   aLots[];
double   _Point, Up, Dn;

datetime pTime;
datetime tcross;
datetime pmin;
datetime CurrBar,PrevBar,LastTradeBar;

string   TSEqFlag;
string   s_symbol;

bool     timecond = false;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{

   
   if (UseAutoMagic) Magic = GetMagic();
               else  Magic = ManualMagic;


   if (MainTimeFrame==0) MainTimeFrame = Period(); 
   
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   PrevBar = iTime(Symbol(),MainTimeFrame,1);
   
   lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   contract = MarketInfo(Symbol(),MODE_LOTSIZE);   
   tick_val = MarketInfo(Symbol(),MODE_TICKVALUE) / MathPow(10,Digits%2);
   minstop  = MarketInfo(Symbol(),MODE_STOPLEVEL) * MathPow(10,Digits%2);
   _Point   =  MarketInfo(Symbol(),MODE_POINT)    * MathPow(10,Digits%2);

   if (IsTesting())
         string nameAddition="testing-"+AccountNumber();
   else         nameAddition=AccountNumber();

   TSEqFlag = nameAddition+AccountNumber()+"_TSEqFlag";      if (!GlobalVariableCheck(TSEqFlag))      GlobalVariableSet(TSEqFlag,0);
   
   return(0);
}

// 
//
//
//
//

int ScanTrades(int ord,int mode)
{   
   int total = OrdersTotal();
   int numords = 0;
   bool type = false; 
   int trd = 0;
   
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if ( ord != 0 )
   {
   if ( OrderType()==0 || OrderType()==2 || OrderType()==4 ) trd =  1;
   if ( OrderType()==1 || OrderType()==3 || OrderType()==5 ) trd =  2;      
   } else trd=0;
   
   if (mode == 0) type = OrderType()<=OP_SELLSTOP;
   if (mode == 1) type = OrderType()<=OP_SELL;   
   if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
   if(OrderSymbol() == Symbol() && type && trd==ord && OrderMagicNumber() == Magic)  
   numords++;
   }
   return(numords);
}  

//
//
//
//
//

//
//
//
//
//

bool TimeCondition()
{
   bool result = false;
    
      if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
      {
         if(StartHour == 24) StartHour = 0; 
      
         datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
         double   Start        = StartHour + StartMinute/60.0;
         datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
         double   End          = EndHour + EndMinute/60.0; 
         
         //
         //
         //
         //
         //
         
         if(DayOfWeek() != 1 && DayOfWeek() != 5)
         {    
            if (Start < End) result = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);  
                
            else
            if (Start > End)result = (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59))||(TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd);
                                   
         }
         else
         if(DayOfWeek() == 1)
         {    
            if(MonStartHour > 0 || MonStartMinute > 0) 
            {
            datetime MonSessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
            double   MonStart        = MonStartHour + MonStartMinute/60.0;
            }
            else
            {
            MonSessionStart = StrToTime(0+":"+0); 
            MonStart        = 0;
            }
            
            //
            //
            //
            //
            //
                        
            if (Start < End)
            { 
              if (MonStart != 0) result = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
                            else result = TimeCurrent() >= SessionStart    && TimeCurrent() < SessionEnd;
            }
            else
            if (Start > End)
            {
               result = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd)|| (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59)); 
                     
            }
         }
         else
         if(DayOfWeek() == 5)
         {
            if(FriEndHour > 0 || FriEndMinute > 0)
            {
            datetime FriSessionEnd = StrToTime(FriEndHour+":"+FriEndMinute);
            double   FriEnd        = FriEndHour + FriEndMinute/60.0; 
            }
            else
            {
            FriSessionEnd = SessionEnd;
            FriEnd        = End; 
            }
            
            //
            //
            //
            //
            //
            
            if (Start < End)
            {
              if (FriEnd != End) result = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
                            else result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;                 
            }
            
            else
            if (Start > End)
               result = (TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd)||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
                           
         }  
      }
   
   return(result);
}   


//
//
//
//
//

double TickSmoother(int mode,int tf,int price,int fast ,int slow,int mamode,int numt,int nums,int maxb,int bar)
{
   int result = 0;
   
   
   if(TS_TimeFrame < 0)
   {  
   tClose = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,3,bar);
   fastMA = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,4,bar);
   slowMA = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,5,bar);
   
   tClose1 = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,3,bar+1);
   fastMA1 = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,4,bar+1);
   slowMA1 = iCustom(NULL,0,"TickSmoother_v2.1",price,fast,slow,mamode,numt,nums,maxb,5,bar+1);
   
   //
   //
   //
   //
   //
   
      if(TS_ConfMA1 > 0 && TS_ConfMA2 > 0)
      {
      confMA1 = iCustom(NULL,0,"TickSmoother_v2.1",price,TS_ConfMA1,TS_ConfMA2,mamode,numt,nums,maxb,4,bar);
      confMA2 = iCustom(NULL,0,"TickSmoother_v2.1",price,TS_ConfMA1,TS_ConfMA2,mamode,numt,nums,maxb,5,bar);
      }
   }
   else
   {
   tClose  = iMA(NULL,tf,1,0,0,price,bar);
   fastMA  = iMA(NULL,tf,fast,0,mamode,price,bar);
   slowMA  = iMA(NULL,tf,slow,0,mamode,price,bar);
   
   tClose1 = iMA(NULL,tf,1,0,0,price,bar+1);
   fastMA1 = iMA(NULL,tf,fast,0,mamode,price,bar+1);
   slowMA1 = iMA(NULL,tf,slow,0,mamode,price,bar+1);
   
   //
   //
   //
   //
   //
   
      if(TS_ConfMA1 > 0 && TS_ConfMA2 > 0)
      {
      confMA1 = iMA(NULL,tf,TS_ConfMA1,0,mamode,price,bar);
      confMA2 = iMA(NULL,tf,TS_ConfMA2,0,mamode,price,bar);
      }
   }
   
   double lim = 0.95 * iClose(NULL,0,0);
   bool ok  = tClose > lim && fastMA > lim && slowMA > lim && tClose1 > lim && fastMA1 > lim && slowMA1 > lim;
   bool ok1 = confMA1 > lim && confMA2 > lim;
     
   if(fastMA > slowMA && fastMA1 < slowMA1 && iTime(NULL,tf,0) != tcross) {cross = 1; tcross = iTime(NULL,tf,0);}
   if(fastMA < slowMA && fastMA1 > slowMA1 && iTime(NULL,tf,0) != tcross) {cross =-1; tcross = iTime(NULL,tf,0);}
   
   //
   //
   //
   //
   //
   
   if(mode==1 && ok)
   {
   if (tClose > fastMA && fastMA > slowMA) result =  mode;
   if (tClose < fastMA && fastMA < slowMA) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==2 && ok)
   {
   if (tClose > fastMA && tClose1 < fastMA1 && fastMA > slowMA) result =  mode;
   if (tClose < fastMA && tClose1 > fastMA1 && fastMA < slowMA) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==3 && ok && ok1)
   {
   if (tClose > fastMA && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2) result =  mode;
   if (tClose < fastMA && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==4 && ok && ok1)
   {
   if (tClose > fastMA && tClose1 < fastMA1 && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2) result =  mode;
   if (tClose < fastMA && tClose1 > fastMA1 && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==5 && ok && ok1)
   {
   double up = iBands(NULL,tf,slow,1,0,price,MODE_UPPER,0);
   double dn = iBands(NULL,tf,slow,1,0,price,MODE_LOWER,0);
   if (tClose > fastMA && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2 && tClose < up && cross == 1) result =  mode;
   if (tClose < fastMA && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2 && tClose > dn && cross ==-1) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==6 && ok && ok1)
   {
   if (tClose > fastMA && fastMA > slowMA && fastMA1 < slowMA1 && slowMA > confMA1 && confMA1 > confMA2) result =  mode;
   if (tClose < fastMA && fastMA < slowMA && fastMA1 > slowMA1 && slowMA < confMA1 && confMA1 < confMA2) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 7)
   {
   if (iRSI(NULL,tf,2,0,1) < 30) result =  mode;
   if (iRSI(NULL,tf,2,0,1) > 70) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 8 && ok && ok1)
   {
   if (iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,4,1) > iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,5,1)) result =  mode;
   
   if (iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,4,1) < iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,5,1)) result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 9 && ok && ok1)
   {
   if (iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,4,1) > iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,5,1)
   && (tClose > fastMA && fastMA > slowMA && slowMA > confMA1 && confMA1 > confMA2))  result =  mode;
   
   if (iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,4,1) < iCustom(NULL,macdtf,"averages MACD",Price,FastPeriod,SlowPeriod,SignalPeriod,Method,true,5,1)
   && (tClose < fastMA && fastMA < slowMA && slowMA < confMA1 && confMA1 < confMA2))  result = -mode;
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//
//
//
//
//

double MA_Confirm(int mode,int tf,int price,int fast ,int slow,int mamode,int bar)
{
   int result = 0;
    
   mClose   = iMA(NULL,tf,1,0,0,price,bar);
   mfastMA  = iMA(NULL,tf,fast,0,mamode,price,bar);
   mslowMA  = iMA(NULL,tf,slow,0,mamode,price,bar);
   
   mClose1  = iMA(NULL,tf,1,0,0,price,bar+1);
   mfastMA1 = iMA(NULL,tf,fast,0,mamode,price,bar+1);
   mslowMA1 = iMA(NULL,tf,slow,0,mamode,price,bar+1);
   
   double lim = 0.95 * Close[0];
   bool   ok  = mClose > lim && mfastMA > lim && mslowMA > lim && mClose1 > lim && mfastMA1 > lim && mslowMA1 > lim;
   
   if(MC_ConfMA1 > 0 && MC_ConfMA2 > 0)
   {
   mconfMA1 = iMA(NULL,tf,MC_ConfMA1,0,mamode,price,bar);
   mconfMA2 = iMA(NULL,tf,MC_ConfMA2,0,mamode,price,bar);
   bool ok1 = mconfMA1 > lim && mconfMA2 > lim;
   }
   
   //
   //
   //
   //
   //  
     
   if(mode==1 && ok)
   {
   if (mClose > mfastMA && mfastMA > mslowMA) result =  mode;
   if (mClose < mfastMA && mfastMA < mslowMA) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==2 && ok)
   {
   if (mClose > mfastMA && mClose1 < mfastMA1 && mfastMA > mslowMA) result =  mode;
   if (mClose < mfastMA && mClose1 > mfastMA1 && mfastMA < mslowMA) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==3 && ok && ok1)
   {
   if (mClose > mfastMA && mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2) result =  mode;
   if (mClose < mfastMA && mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==4 && ok && ok1)
   {
   if (mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2) result =  mode;
   if (mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==5 && ok)
   {
   if (mClose > mfastMA && mfastMA > mslowMA && mfastMA1 < mslowMA1) result =  mode;
   if (mClose < mfastMA && mfastMA < mslowMA && mfastMA1 > mslowMA1) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==6 && ok)
   {
   if (mClose > mfastMA && mfastMA > mslowMA && mfastMA1 < mslowMA1) result =-mode;
   if (mClose < mfastMA && mfastMA < mslowMA && mfastMA1 > mslowMA1) result = mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==7 && ok && ok1)
   {
   double up = iBands(NULL,tf,slow,1,0,price,MODE_UPPER,0);
   double dn = iBands(NULL,tf,slow,1,0,price,MODE_LOWER,0);
   if (mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2 && mClose < up) result =  mode;
   if (mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2 && mClose > dn) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode==8 && ok && ok1)
   {
   up = iBands(NULL,tf,slow,1,0,price,MODE_UPPER,0);
   dn = iBands(NULL,tf,slow,1,0,price,MODE_LOWER,0);
   double AO  = iAO(NULL, tf, bar);
   double AO1 = iAO(NULL, tf, bar+1);
   if (mfastMA > mslowMA && mslowMA > mconfMA1 && mconfMA1 > mconfMA2 && mClose < up && AO > AO1) result =  mode;
   if (mfastMA < mslowMA && mslowMA < mconfMA1 && mconfMA1 < mconfMA2 && mClose > dn && AO < AO1) result = -mode; 
   }
   
   //
   //
   //
   //
   //
   
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

//
//
//
//
//

int TradeSignal()
{   
   int Signal =0;
      
   if (TS_Mode > 0)
   int TS  = TickSmoother(TS_Mode,TS_TimeFrame,TS_Price,TS_FastMA,TS_SlowMA,TS_MA_Mode,TS_NumTicks,TS_NumSecs,TS_MaxBars,TS_Shift); 
   else TS = 0;
   
   if (MC_Mode > 0)
   int MC  = MA_Confirm(MC_Mode,MC_TimeFrame,MC_Price,MC_FastMA,MC_SlowMA,MC_MA_Mode,MC_Shift); 
   else MC = 0;
   
   if (TS == TS_Mode && MC == MC_Mode) Signal = 1;
   if (TS ==-TS_Mode && MC ==-MC_Mode) Signal =-1;
   
   return(Signal);
}

//
//
//
//
//

bool MoneyManagement()
{
   double vol;
   
   //
   //
   //
   //
   //
   
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
   
   //
   //
   //
   //
   //
  
   if (MM == 1)
   vol=NormalizeDouble(AccountFreeMargin()* MaxRisk * AccountLeverage()/contract,2);
   
   else
   if (MM == 2 && MaxLoss > 0)
   vol = NormalizeDouble(AccountFreeMargin()* MaxRisk/MaxLoss,2);
   
   else
   vol = Lots;
   
   //
   //
   //
   //
   //
   
   vol = NormalizeDouble(vol/lot_step,0) * lot_step;
   if (MaxLots(0) > 0) lot_max = MaxLots(0);  
   if (vol < lot_min) vol = lot_min;
   
   //
   //
   //
   //
   //
   
   if(vol <= lot_max ) 
   {
   NumOrders = 1;
   ArrayResize(aLots,NumOrders);
   aLots[NumOrders-1] = vol;
   if(vol < lot_min) aLots[NumOrders-1] = lot_min;
   }
   
   //
   //
   //
   //
   //
     
   else
   if(vol > lot_max)
   {
   NumOrders = 1+MathFloor(vol/lot_max); 
   if(NumOrders > MaxOrders) NumOrders = MaxOrders; 
   
   ArrayResize(aLots,NumOrders);
      double SumVol = 0;
      
      for (int i=0; i<NumOrders-1;i++)
      {
      aLots[i] = MathCeil(vol/lot_step/NumOrders) * lot_step;
      if(aLots[i] > lot_max) aLots[i] = lot_max; 
      SumVol += aLots[i];
      }
      aLots[NumOrders-1] = vol - SumVol; 
      if (aLots[NumOrders-1] > lot_max) aLots[NumOrders-1] = lot_max;
   }   
   
   //
   //
   //
   //
   //
   
   if (NumOrders > 0) return(true);
}   

//
//
//
//
//

void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
   
   //
   //
   //
   //
   //
   
   int    total = OrdersTotal(); 
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if (BreakEven > 0 && BEvent < total )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/_Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice() + PipsLock *_Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice() + PipsLock * _Point,Digits);
			      BEvent+=1;
			      }
			   }
			   
			   //
			   //
			   //
			   //
			   //
			   
			   else			   
			   if (TrailingMode == 1 && TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop * _Point,Digits);
			   else
			   if (TrailingMode == 2 && Dn > 0) BuyStop = NormalizeDouble((1.0-0.01 * StopDeviation) * Dn,Digits);
			   
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if ( BuyStop > NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),BuyStop,OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         } 
           
         // 
         //
         //
         //
         //
                  
         if (mode==OP_SELL)
         {
            if (BreakEven > 0 && BEvent > -total)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/_Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-PipsLock * _Point || OrderStopLoss() == 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-PipsLock * _Point,Digits);
			      BEvent-=1;
			      }
			   }
			   
			   //
			   //
			   //
			   //
			   //
			   
			   else 
			   if (TrailingMode == 1 && TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop * _Point,Digits);   
            else
            if (TrailingMode == 2 && Up > 0) SellStop = NormalizeDouble((1.0 + 0.01 * StopDeviation) * Up,Digits);
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop > 0) 
            {
               if( SellStop < NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),SellStop,OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}

// 
//
//
//
//

void SellOrdOpen(double mult)
{		     
   double Stop,Profit;
   int ticket = 0;
   int tr = 1;
   
   int    Mode = OP_SELL;
      
   
	
	if(MoneyManagement())
	{
      for (int i=0; i<NumOrders;i++)
      {		
	   double SellPrice = Bid;
      double StopPrice = Bid;
	   
	   if (StopLoss > 0) double SellStop  = SellPrice + StopLoss*_Point; 
	   else
	   if (TrailingMode==2 && Up > 0) SellStop = NormalizeDouble((1.0+0.01*StopDeviation)*Up,Digits); 
	   else 
	   SellStop = 0;
   
      if (StopLoss > 0 && SellStop - Ask < 10*_Point) SellStop  = SellPrice + 10 *_Point;     
   
      if (MM == 2 && SellStop > 0) MaxLoss = tick_val*(SellStop-Bid)/_Point;    
      if (TakeProfit  > 0) double SellProfit = SellPrice - TakeProfit*_Point; 
      else 
      SellProfit=0;
	   
	   if(mult == 0) double lots = aLots[i];
      else
      if(mult  > 0) lots = mult*MaxLots(2);
           
	   if(ECN_Mode == 1) { Stop=0; Profit=0; }
	   else { Stop = SellStop; Profit = SellProfit; } 
	        
         while ( ticket <= 0 && tr <= TriesNum)
         {     
	      ticket = OrderSend(Symbol(),Mode,lots,NormalizeDouble(SellPrice,Digits),Slippage*_Point,NormalizeDouble(Stop,Digits),NormalizeDouble(Profit,Digits),Expert_Name+" SELL",Magic,0,Red);
   
            if(ticket > 0) 
            {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) { BEvent=0; cross = 0; } 
            if(ECN_Mode == 1 && (SellStop > 0 || SellProfit > 0)) OrderModify(ticket,OrderOpenPrice(),SellStop,SellProfit,0,Magenta);
            }
      	   else
      	   if(ticket < 0)
	         { 	
            Sleep(5000);
            RefreshRates();
            tr += 1;
            if(GetLastError()>0)      
            Print("SELL : OrderSend failed with error #",ErrorDescription(GetLastError()));
            } 	
         }    
      }
   }      
}

// 
//
//
//
//

void BuyOrdOpen(double mult)
{		     
   double Stop,Profit;
   int ticket = 0;
   int tr = 1;
   
   int    Mode      = OP_BUY;
   
	if (MoneyManagement())
	{	  
      for (int i=0; i<NumOrders;i++)
      {	
      double BuyPrice  = Ask;
      double StopPrice = Ask;  
      
      if (StopLoss > 0) double BuyStop  = BuyPrice - StopLoss*_Point; 
      else 
	   if (TrailingMode==2 && Dn > 0) BuyStop = NormalizeDouble((1.0-0.01*StopDeviation)*Dn,Digits); 
	   else 
      BuyStop = 0;
      
      if (StopLoss > 0 && Bid - BuyStop < 10*_Point) BuyStop  = BuyPrice - 10 *_Point; 	   
      if (MM == 2 && BuyStop > 0) MaxLoss = tick_val*(Ask - BuyStop)/_Point; 
           
      if (TakeProfit  > 0) double BuyProfit= BuyPrice + TakeProfit*_Point;   
	   else 
	   BuyProfit=0;
      
      if(mult == 0) double lots = aLots[i];
      else
      if(mult  > 0) lots = mult*MaxLots(1);
            
      if(ECN_Mode == 1) {Stop=0; Profit=0;}
	   else {Stop = BuyStop; Profit = BuyProfit;}     
               
         while ( ticket <= 0 && tr <= TriesNum)
         {     
         ticket = OrderSend(Symbol(),Mode,lots,NormalizeDouble(BuyPrice,Digits),Slippage*_Point,NormalizeDouble(Stop,Digits),NormalizeDouble(Profit,Digits),Expert_Name+" BUY",Magic,0,Blue);
      
            if(ticket > 0) 
            {
            if (OrderSelect(ticket,SELECT_BY_TICKET, MODE_TRADES)) { BEvent=0; cross = 0; } 
            if(ECN_Mode == 1 && (BuyStop > 0 || BuyProfit > 0)) OrderModify(ticket,OrderOpenPrice(),BuyStop,BuyProfit,0,Aqua);
            }
	         else
	         if(ticket < 0)
	         { 	
            Sleep(5000);
            RefreshRates();
            tr += 1;
            if(GetLastError()>0)      
            Print("BUY : OrderSend failed with error #",ErrorDescription(GetLastError()));
            } 	    
         }
      }
   }     
} 

//
//
//
//
//

void CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=OrdersTotal(); i>=0; i--)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode == 1) && OrderType()==OP_BUY ) { result = CloseAtMarket(OrderTicket(),OrderLots(),Aqua); break; }
      if ((mode == 0 || mode == 2) && OrderType()==OP_SELL) { result = CloseAtMarket(OrderTicket(),OrderLots(),Pink); break; }
      }
   }
}

//
//
//
//
//

bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage*_Point,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

//
//
//
//
//

double TotalProfit(int trade,int pmode,int hmode,datetime date)
{
   double Pips = 0, profit=0, totalPips = 0, totalProfits = 0, mPips = 0;   
      
      if(hmode == 0) 
      {
      int total = OrdersTotal(); 
      int opt =  MODE_TRADES;
      }
      else 
      {
      total = OrdersHistoryTotal();
      opt =  MODE_HISTORY;
      }
      
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS, opt);   
   
   int mode=OrderType();
   bool mcondition = false, dcondition = false;
   
   if ( Magic>0 && OrderMagicNumber()==Magic && OrderSymbol() == Symbol()) mcondition = true;
   else if ( Magic==0 ) mcondition = true;   
   
   if(date > 0)
   { 
   if(date == StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE))) dcondition = true;
   }
   else
   if(date == 0) dcondition = true;  
       
      if (mcondition && dcondition)
      {      
         if (mode == OP_BUY && (trade == 1 || trade == 0))
         {
         Pips = (OrderClosePrice() - OrderOpenPrice())/_Point;
         profit = OrderProfit() + OrderSwap() + OrderCommission();
         totalPips += Pips;
         totalProfits += profit;
         if(pmode == 4 && OrderLots() == MaxLots(1)) mPips = Pips; 
         }
         
         if (mode == OP_SELL && (trade == 2 || trade == 0))   
         {          
         Pips = (OrderOpenPrice() - OrderClosePrice())/_Point;
         profit = OrderProfit() + OrderSwap() + OrderCommission();
         totalPips += Pips;
         totalProfits += profit;
         if(pmode == 4 && OrderLots() == MaxLots(2)) mPips = Pips; 
         }
      }            
	}
   if(pmode==0) return(Pips);
   else
   if(pmode==1) return(profit);
   else
   if(pmode==2) return(totalPips);
   else
   if(pmode==3) return(totalProfits);
   else
   if(pmode==4) return(mPips);
}

//
//
//
//
//

double MaxLots(int trade)
{
   int total = OrdersTotal();
   double maxlot = 0;  
     
   for (int cnt=0;cnt<total;cnt++)
   { 
   if(!OrderSelect(cnt, SELECT_BY_POS)) break;   
      if (OrderMagicNumber()==Magic && OrderSymbol() == Symbol()) 
      {
      if (OrderType() == OP_BUY  && (trade == 1 || trade == 0)) maxlot = MathMax(maxlot,OrderLots()); 
      if (OrderType() == OP_SELL && (trade == 2 || trade == 0)) maxlot = MathMax(maxlot,OrderLots()); 
      }
   }
   return(maxlot);
}

//
//
//
//
//

bool canOpen(int openWhat)
{
   if (!NoHedge) return(true);

   //
   //
   //
   //
   //
      
      for(int i=0; i < OrdersTotal(); i++)
      {
         if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
         if (OrderSymbol() != Symbol())                     continue;
         if (!StrictNoHedge && OrderMagicNumber() != Magic) continue;
      
         if (OrderType() == OP_BUY  && openWhat == OP_SELL) return(false); 
         if (OrderType() == OP_SELL && openWhat == OP_BUY)  return(false); 
   }      
   return(true);
}

//
//
//
//
//

void CloseAll()
{
   if (!IsTradeAllowed()) return;

   Comment("\nEquity Closure Triggered, We will close all trades on every pair.");

   //
   //
   //
   //
   //
   
   for(int cnt=OrdersTotal()-1;cnt>=0;cnt--)
   {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderMagicNumber()<Magic)   continue;

      string closingWhat = "";
         if (OrderType() == OP_BUY)  closingWhat = "BUY";
         if (OrderType() == OP_SELL) closingWhat = "SELL";
         if (closingWhat=="") continue;
               
      //
      //
      //
      //
      //
                     
      for(int c=0; c<TriesNum; c++)
      {
         RefreshRates();
         OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),Slippage*_Point,Yellow);
         int err=GetLastError();
         if (err==0) break;
      
            //
            //
            //
            //
            //
               
            Print("Errors Closing "+closingWhat+"order");
            Print(ErrorDescription(err),", error ",err);
            if(err==0 || err==4 || err==136 || err==137 || err==138 || err==146)
            {
               Sleep(5000);
               continue;
            }  
         break;
      }               
   }       
}

//
//
//
//
//

int GetMagic() 
{
   if (s_symbol == SymbolsPrefix+"CADJPY"+SymbolsSuffix) return(1821);
   if (s_symbol == SymbolsPrefix+"CADCHF"+SymbolsSuffix) return(1822);
   
   if (s_symbol == SymbolsPrefix+"GOLD"  +SymbolsSuffix) return(1831);
   if (s_symbol == SymbolsPrefix+"SILVER"+SymbolsSuffix) return(1832);
   
   if (s_symbol == SymbolsPrefix+"NZDJPY"+SymbolsSuffix) return(1841);
   if (s_symbol == SymbolsPrefix+"NZDUSD"+SymbolsSuffix) return(1842);
   
   if (s_symbol == SymbolsPrefix+"CHFJPY"+SymbolsSuffix) return(1851);
   
   if (s_symbol == SymbolsPrefix+"EURAUD"+SymbolsSuffix) return(1861);
   if (s_symbol == SymbolsPrefix+"EURCAD"+SymbolsSuffix) return(1862);
   if (s_symbol == SymbolsPrefix+"EURUSD"+SymbolsSuffix) return(1863);
   if (s_symbol == SymbolsPrefix+"EURGBP"+SymbolsSuffix) return(1864);
   if (s_symbol == SymbolsPrefix+"EURCHF"+SymbolsSuffix) return(1865);
   if (s_symbol == SymbolsPrefix+"EURNZD"+SymbolsSuffix) return(1866);
   if (s_symbol == SymbolsPrefix+"EURJPY"+SymbolsSuffix) return(1867);
   
   if (s_symbol == SymbolsPrefix+"GBPUSD"+SymbolsSuffix) return(1871);
   if (s_symbol == SymbolsPrefix+"GBPCHF"+SymbolsSuffix) return(1872);
   if (s_symbol == SymbolsPrefix+"GBPJPY"+SymbolsSuffix) return(1873);
   
   if (s_symbol == SymbolsPrefix+"USDCHF"+SymbolsSuffix) return(1881);
   if (s_symbol == SymbolsPrefix+"USDJPY"+SymbolsSuffix) return(1882);
   if (s_symbol == SymbolsPrefix+"USDCAD"+SymbolsSuffix) return(1883);

   if (s_symbol == SymbolsPrefix+"AUDUSD"+SymbolsSuffix) return(1891);
   if (s_symbol == SymbolsPrefix+"AUDNZD"+SymbolsSuffix) return(1892);
   if (s_symbol == SymbolsPrefix+"AUDCAD"+SymbolsSuffix) return(1893);
   if (s_symbol == SymbolsPrefix+"AUDCHF"+SymbolsSuffix) return(1894);
   if (s_symbol == SymbolsPrefix+"AUDJPY"+SymbolsSuffix) return(1895);
   
   //
   //
   //    some other symbol, use manual magic number
   //
   //
   
   return(ManualMagic);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
   double pips = TotalProfit(0,2,0,0);
   double usd  = TotalProfit(0,3,0,0);
   double hist = TotalProfit(0,3,1,StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)));
   double sum  = hist + usd;     
   
   sComment = sp;
   sComment = sComment+"Expert Name : "+Expert_Name+NL;
   if(TimeCondition()) string tc = "Trade Time"; else tc = "Not Trade Time"; 
   sComment = sComment+"Current Time : "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS) + " DayOfWeek : " + TimeDayOfWeek(TimeCurrent()) + " Time Condition : " + tc + NL;
   sComment = sComment+"Orders: Open= "+ScanTrades(0,1)+" Pending= "+ScanTrades(0,2)+" All= "+ScanTrades(0,0)+NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToStr(pips,1) + NL;
   sComment = sComment+"Current Profit(USD) = " + DoubleToStr(usd,2)  + NL;
   sComment = sComment+"Daily Profit(USD): Closed= " + DoubleToStr(hist,2) + " Open= " + DoubleToStr(usd,2) + " Summary = " + DoubleToStr(sum,2) + NL; 
   
   sComment = sComment+sp;
   sComment = sComment + "Fast0=" + DoubleToStr(fastMA,Digits) + " Slow0=" + DoubleToStr(slowMA,Digits) + " Close0=" + DoubleToStr(tClose,Digits)+NL; 
   sComment = sComment + "Fast1=" + DoubleToStr(fastMA1,Digits) + " Slow1=" + DoubleToStr(slowMA1,Digits) + " Close1=" + DoubleToStr(tClose1,Digits)+NL; 
   if(TS_ConfMA1 > 0 && TS_ConfMA2 > 0)
   sComment = sComment + "Conf1=" + DoubleToStr(confMA1,Digits) + " Conf2=" + DoubleToStr(confMA2,Digits) + NL;
    
   
   Comment(sComment);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit()  
{   
   Comment(""); 
   
   if (IsTesting())
   {
      GlobalVariableDel(TSEqFlag);
   }
   
return(0);  
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   if(iBars(Symbol(),MainTimeFrame) < 100 || !IsTradeAllowed()) return(0); 
   
   if(MainTimeFrame >= 0) 
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   else 
   {
   CurrBar = iTime(Symbol(),0,0);
   PrevBar = iTime(Symbol(),0,1);  
   }
   
   datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
   if(FriCloseHour >= 0 && DayOfWeek() == 5 && FriCloseHour > StartHour) TimeClose = StrToTime(FriCloseHour+":"+FriCloseMinute); 
   
   spread = NormalizeDouble((Ask - Bid)/_Point,1);
   if(DisplayComments) ChartComment();
   
   if (CurrBar != PrevBar)
   {
      int b_trades = ScanTrades(1,0);
      int s_trades = ScanTrades(2,0);
      int trades   = b_trades + s_trades;
   
      if(TS_Mode != 0 || MC_Mode != 0) int Signal = TradeSignal();
   }   
      if(trades == 0 && !TimeCondition()) return(0); 
        
      if(trades > 0)
      {
         if(ExitMode == 1)
         {
         if (s_trades > 0 && fastMA > slowMA && slowMA > 0) 
         {
         Print("Sell Close 1"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && fastMA < slowMA && slowMA > 0) 
         {
         Print("Buy Close 1") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 2)
         {
         if (s_trades > 0 && tClose1 < fastMA1 && tClose > fastMA && fastMA > 0 && fastMA1 > 0) 
         {
         Print("Sell Close 2"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && tClose1 > fastMA1 && tClose < fastMA ) 
         {
         Print("Buy Close 2") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
          
         else
         if(ExitMode == 3)
         {
         double gain = TotalProfit(0,1,0,0); 
         if (s_trades > 0 && ((tClose1 < fastMA1 && tClose > fastMA && fastMA > 0 && fastMA1 > 0 && gain > 0) || tClose >= confMA1)) 
         {
         Print("Sell Close 3"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && ((tClose1 > fastMA1 && tClose < fastMA && gain > 0) || tClose <= confMA1)) 
         {
         Print("Buy Close 3") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
              
         else
         if(ExitMode == 4)
         {
         double b_gain = TotalProfit(1,1,0,0); 
         double s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && ((tClose > fastMA && fastMA > 0 && s_gain > 0) || tClose >= confMA2)) 
         {
         Print("Sell Close 4"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && ((tClose < fastMA && b_gain > 0) || tClose <= confMA2)) 
         {
         Print("Buy Close 4") ; while(ScanTrades(1,0)>0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
         
         else    
         if(ExitMode == 5)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && ((tClose > fastMA && fastMA > 0 && s_gain > 0) || tClose >= mconfMA2)) 
         {
         Print("Sell Close 5"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && ((tClose < fastMA && b_gain > 0) || tClose <= mconfMA2)) 
         {
         Print("Buy Close 5") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
             
         else    
         if(ExitMode == 6)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && ((mClose > mfastMA && mfastMA > 0 && s_gain > 0) || mClose >= mconfMA2)) 
         {
         Print("Sell Close 6"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && ((mClose < mfastMA && b_gain > 0) || mClose <= mconfMA2)) 
         {
         Print("Buy Close 6") ; while(ScanTrades(1,0)>0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
             
         else    
         if(ExitMode == 7)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && (mClose > mfastMA && mfastMA > 0 && s_gain > 0)) 
         {
         Print("Sell Close 7"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && (mClose < mfastMA && b_gain > 0)) 
         {
         Print("Buy Close 7") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         }
         
         //
         //
         //
         //
         //
         
         else    
         if(ExitMode == 8)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         if (s_trades > 0 && (mfastMA > mfastMA1 && mfastMA1 > 0 && s_gain > 0)) 
         {
         Print("Sell Close 8"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && (mfastMA < mfastMA1 && b_gain > 0)) 
         {
         Print("Buy Close 8") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         } 
         
         //
         //
         //
         //
         //
              
         else    
         if(ExitMode == 9)
         {
         b_gain = TotalProfit(1,1,0,0); 
         s_gain = TotalProfit(2,1,0,0); 
         double up = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,TS_Price,MODE_UPPER,0);
         double dn = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,TS_Price,MODE_LOWER,0);
         if (s_trades > 0 && ((((tClose > fastMA && fastMA > 0)|| tClose < dn) && s_gain > 0))) 
         {
         Print("Sell Close 9"); while(ScanTrades(2,0) > 0) CloseOrder(2);
         }
         
         if (b_trades > 0 && ((((tClose < fastMA) || tClose > up) && b_gain > 0))) 
         {
         Print("Buy Close 9") ; while(ScanTrades(1,0) > 0) CloseOrder(1);
         }
         }  
         
         //
         //
         //
         //
         //
           
         else    
         if(ExitMode == 10)
         {
         b_gain = TotalProfit(1,0,0,0); 
         s_gain = TotalProfit(2,0,0,0); 
         double t_up = iBands(NULL,TS_TimeFrame,TS_SlowMA,2,0,TS_Price,MODE_UPPER,1);
         double t_dn = iBands(NULL,TS_TimeFrame,TS_SlowMA,2,0,TS_Price,MODE_LOWER,1);
         up = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,MC_Price,MODE_UPPER,0);
         dn = iBands(NULL,MC_TimeFrame,MC_SlowMA,2,0,MC_Price,MODE_LOWER,0);
         
         if (s_trades > 0 && ((fastMA > slowMA ||  iLow(NULL,MC_TimeFrame,0) <= dn ||  iLow(NULL,TS_TimeFrame,1) <= t_dn) && s_gain >= MinProfit)) 
         {
         Print("Sell Close 10"); CloseOrder(2);
         }
         
         if (b_trades > 0 && ((fastMA < slowMA || iHigh(NULL,MC_TimeFrame,0) >= up || iHigh(NULL,TS_TimeFrame,1) >= t_up) && b_gain >= MinProfit)) 
         {Print("Buy Close 10"); CloseOrder(1);
         }
         } 
         
         //
         //
         //
         //
         //
            
         else
         if(ExitMode == 11)
         {

         if (trades > 0 && TotalProfit(0,0,0,0) >= MGPips) while(ScanTrades(0,0) > 0) CloseOrder(0);
      
         }
         
         //
         //
         //
         //
         //
         
         else
         if(ExitMode == 12)
         {
         if (trades > 0 &&  TotalProfit(0,ProfitMode,0,0) > ProfitTarget) while(ScanTrades(0,0) > 0) CloseOrder(0);
         }
         
         //
         //
         //
         //
         //
         
         if (CloseTimeMode > 0 && TimeCurrent() >= TimeClose && TimeCurrent() < TimeClose+ProcessTime*60) while(ScanTrades(0,0)>0) CloseOrder(0); 
         }
         
         //
         //
         //
         //
         //
            
         if(MaxSpread > 0) bool spreadOK = spread <= MaxSpread; else spreadOK = true;
         
         EquityStop = GlobalVariableGet(TSEqFlag);
      
         trades = ScanTrades(0,0);
         datetime min = iTime(NULL,1,0);
         if(min != pmin) { timecond = TimeCondition(); pmin = min; }
   
         if(!timecond && trades == 0) return(0);     
   
         if(timecond || (!timecond && trades > 0)) Signal = TradeSignal();   
         
         if(trades == MaxOrders)
         {
           if (EquityTrailing==true && AccountEquity()>=AccountBalance()+(AccountBalance()*PercentEquityTrailing/100)) 
           {
             Alert("Closing orders because account Equity Trailing was triggered. Balance: ",AccountBalance()," Equity: ", AccountEquity());	 
             EquityStop=1;
             GlobalVariableSet(TSEqFlag,EquityStop);
             CloseAll();
           }
         return(0);
         }    
         
         if(trades < MaxOrders)
         {
         if (TimeCondition() && spreadOK && Time[0] != pTime && Signal != 0)
         {
            if((Signal > 0 && MGMode==0 && canOpen(OP_BUY)) || (Signal > 0 && MGMode > 0 && trades < 1 && canOpen(OP_BUY))) 
            {
            if(ReverseLogic > 0) SellOrdOpen(0);
            else BuyOrdOpen(0);
            } 
         
            if((Signal < 0 && MGMode==0 && canOpen(OP_SELL)) || (Signal < 0 && MGMode > 0 && trades < 1 && canOpen(OP_SELL))) 
            {
            if(ReverseLogic > 0) BuyOrdOpen(0);
            else SellOrdOpen(0);
            } 
            
         pTime = Time[0];
         }   
      
         if (MGMode > 0 && trades > 0)
         {
            
         double b_pips = TotalProfit(1,0,0,0);  
         double s_pips = TotalProfit(2,0,0,0);   
            if(AccountFreeMargin() > AccountBalance()*0.5)
            {
            if(b_pips <= -(MGStep)) BuyOrdOpen(MGRatio);
            if(s_pips <= -(MGStep)) SellOrdOpen(MGRatio);
            }
         }
           
      }
   //
   //
   //
   //
   //
  
   if(trades > 0)
   {
   if(ProfitTarget > 0 && TotalProfit(0,ProfitMode,0,0) >= ProfitTarget) while(ScanTrades(0,0)>0) CloseOrder(0); 
   if(BreakEven > 0 || TrailingMode>0) TrailStop();
   }
      
   PrevBar = CurrBar;
   
   return(0);
} 

//+------------------------------------------------------------------+

